package com.plantas.plantasalicante;

import android.app.Activity;
import android.hardware.Camera;
import android.hardware.Camera.Parameters;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.widget.FrameLayout;

public class Camara extends Activity {


	private Camera camera;
	private ShowCamera showcamera;
	Parameters params;
	float mX,mY;
	float mXInicial, mYInicial;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_camara);
		getCamera();
		showcamera = new ShowCamera(this, camera);
		FrameLayout preview = (FrameLayout) findViewById(R.id.camera_preview);
		preview.addView(showcamera);

	}

	private void getCamera() {
		if (camera == null) {
			try {
				camera = Camera.open();
				params = camera.getParameters();
			} catch (RuntimeException e) {
				Log.e("Camera Error. Failed to Open. Error: ", e.getMessage());
				finish();
			}
		}
	}
	
	public void onResume(){
		super.onResume();
		getCamera();
		
	}
	
	public void onPause(){
		super.onPause();
		camera.release();
	}
	
	public boolean onTouchEvent (MotionEvent event) {
		super.onTouchEvent(event);
		float x = event.getX();
		float y = event.getY();
		switch (event.getAction()) {
		case MotionEvent.ACTION_DOWN:
			mXInicial = x;
			mYInicial = y;
			break;
		case MotionEvent.ACTION_MOVE:
				break;
		case MotionEvent.ACTION_UP:
			//debemos cambiar el zoom
			//llamamos al cambio de zoom
			//comprobamos la diferencia de Y
			if (mYInicial - y > 50){
				//debemos subir el zoom
				subirzoom();
			}
			else{
				if(y - mYInicial > 50){
				//debemos bajar el zoom
				bajarzoom();
			}}
			break;
		}     
		return true;

	}
	
	private void subirzoom(){
		Parameters parametros = camera.getParameters();
		int maxzoom = parametros.getMaxZoom();
		int actualzoom = parametros.getZoom();
		actualzoom+=2;
		if(parametros.isZoomSupported() && actualzoom <= maxzoom){
			parametros.setZoom(actualzoom);
			camera.setParameters(parametros);
			showcamera.surfaceChanged(null, 0, 0, 0);
		}
		else{
			return;
		}
		
	}
	
	private void bajarzoom(){
		Camera.Parameters parametros = camera.getParameters();
		int actualzoom = parametros.getZoom();
		actualzoom-=2;
		if (parametros.isZoomSupported() && actualzoom >= 0) {
			parametros.setZoom(actualzoom);
			camera.setParameters(parametros);
			showcamera.surfaceChanged(null, 0, 0, 0);
		}
		else{
			return;
		}
	}
	
}
