package com.plantas.plantasalicante;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

/**
 * Clase que permite representar la clave Bonnier
 * @version 1.0, 05/11/14
 * @author Jose Manuel Castellano Dominguez
 */
public class Clave extends Activity {
	private int numpregunta;
	private static PlantasClaveSQL plantasClaveSQL;
	private int numopcion1;
	private int numopcion2;
	private int numopcion3;
	private int numopcion4;
	private int numopcion5;

	/** 
	 * Crea la actividad de Clave
	 * @param savedInstanceState Estado anterior de la actividad.
	 */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_clave);
		numpregunta = getIntent().getIntExtra("numpregunta", 0);
		//debemos buscar la pregunta en la base de datos
		//tenemos que buscar la pregunta en la base de datos
		plantasClaveSQL = new PlantasClaveSQL(this);
		SQLiteDatabase db = plantasClaveSQL.getReadableDatabase();
		//lanzamos una query para saber el texto de la pregunta

		String[] param  = new String[1];
		param[0] = "" + numpregunta;
		Cursor cursor = db.rawQuery("SELECT * FROM ClavePlantasOpcionRespuesta WHERE _id= ? ", param);
		//ok ya tenemos las opciones de las preguntas 
		//ahora debemos sacar todas las opciones y respuestas y ponerlas
		if(!cursor.moveToNext()){
			//no se encontro la pregunta debemos abortar la actividad
			finish();
			return;
		}

		//vamos 1 a 1 las opciones, si la opcion es 0 directamente ponemos un GONE
		TextView primera = (TextView) findViewById(R.id.opcion1);
		if(cursor.getInt(cursor.getColumnIndex("primera")) != 0){
			//tiene opcion debemos averiguar el texto que viene con el
			int num = cursor.getInt(cursor.getColumnIndex("primera"));
			numopcion1=num;
			String[] params  = new String[1];
			params[0] = "" + num;
			Cursor doscursor = db.rawQuery("SELECT texto FROM ClavePlantas WHERE _id= ? ", params);
			if(!doscursor.moveToNext()){
				//no se encontro la pregunta debemos abortar la actividad
				Log.e("Plantas", "textopregunta no encontrado " + num);
				finish();
				return;
			}
			primera.setText(doscursor.getString(doscursor.getColumnIndex("texto")));

		}
		else{
			primera.setVisibility(View.GONE);
		}

		//vamos con la segunda opcion
		TextView segunda = (TextView) findViewById(R.id.opcion2);
		if(cursor.getInt(cursor.getColumnIndex("segunda")) != 0){
			//tiene opcion debemos averiguar el texto que viene con el
			int num = cursor.getInt(cursor.getColumnIndex("segunda"));
			numopcion2=num;
			String[] params  = new String[1];
			params[0] = "" + num;
			Cursor doscursor = db.rawQuery("SELECT texto FROM ClavePlantas WHERE _id= ? ", params);
			if(!doscursor.moveToNext()){
				//no se encontro la pregunta debemos abortar la actividad
				finish();
				return;
			}
			segunda.setText(doscursor.getString(doscursor.getColumnIndex("texto")));

		}
		else{
			segunda.setVisibility(View.GONE);
		}

		//vamos con la tercera opcion
		TextView tercera = (TextView) findViewById(R.id.opcion3);
		if(cursor.getInt(cursor.getColumnIndex("tercera")) != 0){
			//tiene opcion debemos averiguar el texto que viene con el
			int num = cursor.getInt(cursor.getColumnIndex("tercera"));
			numopcion3=num;
			String[] params  = new String[1];
			params[0] = "" + num;
			Cursor doscursor = db.rawQuery("SELECT texto FROM ClavePlantas WHERE _id= ? ", params);
			if(!doscursor.moveToNext()){
				//no se encontro la pregunta debemos abortar la actividad
				finish();
				return;
			}
			tercera.setText(doscursor.getString(doscursor.getColumnIndex("texto")));

		}
		else{
			tercera.setVisibility(View.GONE);
		}

		//vamos con la cuarta opcion
		TextView cuarta = (TextView) findViewById(R.id.opcion4);
		if(cursor.getInt(cursor.getColumnIndex("cuarta")) != 0){
			//tiene opcion debemos averiguar el texto que viene con el
			int num = cursor.getInt(cursor.getColumnIndex("cuarta"));
			numopcion4=num;
			String[] params  = new String[1];
			params[0] = "" + num;
			Cursor doscursor = db.rawQuery("SELECT texto FROM ClavePlantas WHERE _id= ? ", params);
			if(!doscursor.moveToNext()){
				//no se encontro la pregunta debemos abortar la actividad
				finish();
				return;
			}
			cuarta.setText(doscursor.getString(doscursor.getColumnIndex("texto")));

		}
		else{
			cuarta.setVisibility(View.GONE);
		}

		//vamos con la ultima opcion
		TextView quinta = (TextView) findViewById(R.id.opcion5);
		if(cursor.getInt(cursor.getColumnIndex("quinta")) != 0){
			//tiene opcion debemos averiguar el texto que viene con el
			int num = cursor.getInt(cursor.getColumnIndex("quinta"));
			numopcion5=num;
			String[] params  = new String[1];
			params[0] = "" + num;
			Cursor doscursor = db.rawQuery("SELECT texto FROM ClavePlantas WHERE _id= ? ", params);
			if(!doscursor.moveToNext()){
				//no se encontro la pregunta debemos abortar la actividad
				finish();
				return;
			}
			quinta.setText(doscursor.getString(doscursor.getColumnIndex("texto")));

		}
		else{
			quinta.setVisibility(View.GONE);
		}

		//con esto estan las preguntas puesta, ahora hay que esperar que el usuario clicke en una de ellas.
	}

	/** 
	 * Metodo que permite ir a la actividad de Lupa
	 * @param view Vista sobre la que se pulso.
	 */
	public void goLupa(View view){
		//tenemos que ir a la lupa
		this.startActivity(new Intent(this,Camara.class));
	}
	/** 
	 * Metodo que permite ir a la opcion elegida en la clave
	 * @param view Vista sobre la que se pulso.
	 */
	public void opcionelegida(View view){
		//rescatamos sobre que opcion pulso el usuario
		String opcion = view.getTag().toString();
		//ahora segun la opcion debemos actuar en consecuencia
		int proximonum=numopcion1;
		if(opcion.equals("Opcion1")){
			proximonum=numopcion1;
		}
		if(opcion.equals("Opcion2")){
			proximonum=numopcion2;
		}
		if(opcion.equals("Opcion3")){
			proximonum=numopcion3;
		}
		if(opcion.equals("Opcion4")){
			proximonum=numopcion4;
		}
		if(opcion.equals("Opcion5")){
			proximonum=numopcion5;
		}
		
		//primero debemos mirar si llegamos a una planta, si llegamos es mostrarla y listo
		SQLiteDatabase db = plantasClaveSQL.getReadableDatabase();
		String[] params  = new String[1];
		params[0] = "" + proximonum;
		Cursor cursor = db.rawQuery("SELECT planta FROM ClavePlantasOpcionPlanta WHERE _id= ? ", params);
		if(cursor.moveToNext()){
			//existe planta, se debe mostrar
			Intent intent = new Intent(this,Ver_Planta.class);
			intent.putExtra("planta", cursor.getString(cursor.getColumnIndex("planta")));
			startActivity(intent);
		}
		else{
			//no hemos llegado a la planta debemos ir a la siguiente pregunta
			Intent intent = new Intent(this,Clave.class);
			intent.putExtra("numpregunta",proximonum);
			startActivity(intent);
		}
	}
	
	/** 
	 * Metodo que permite crear un menu en la actividad
	 * @param menu Menu que debe inflarse para mostrarse
	 */
	@Override 
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.menu, menu);
		return true; 

	}


	/** 
	 * Metodo que permite clickar sobre las opciones del men
	 * @param item Opcion del menu pulsada
	 */
	@Override 
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.acercaDe:
			//ir al acercade
			startActivity(new Intent(this,AcercaDe.class));
			break;
		case R.id.config:
			//ir a las preferencias
			startActivity(new Intent(this,Preferencias.class));
			break;
		case R.id.usarLupa:
			//ir a la lupa
			startActivity(new Intent(this,Camara.class));
			break;
		case R.id.mapa:
			//ir al mapa
			startActivity(new Intent(this,MapaPlantas.class));
			break;
		}
		return true; 
	}
}
