package com.plantas.plantasalicante;

import java.util.Timer;
import java.util.TimerTask;


import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.View;

/**
 * Una clase para representar el menu de Creditos
 * @version 1.0, 05/11/14
 * @author Jose Manuel Castellano Dominguez
 */
public class Creditos extends View {
	private Context context;
	private int fase;
	private int count;
	
	/** 
     * Constructor de Creditos
     * @param context Contexto de la actividad que ejecuta los creditos
     */
	public Creditos(Context context){
		super(context);
		this.context = context;
		count = 0;
		fase = 0;
		TimerTask timerTask = new TimerTask()
		{
			public void run() 
			{
				//este codigo controlara las zonas a seleccionar y las dibujara
				//ha pasado un segundo, sumamos
				count++;
				switch(count){
				//segun el valor de count o no hacemos nada o modificamos el estado y llamamos a invalidate
				case 5: fase = 1; postInvalidate(); break;
				case 8: fase = 2; postInvalidate(); break;
				case 13: fase = 3; postInvalidate(); break;
				case 18: fase = 4; postInvalidate(); break;
				case 25: fase = 5; postInvalidate(); break;
				case 30: fase = 6; postInvalidate(); break;
				case 35: fase = 7; postInvalidate(); break;
				case 40: fase = 8; postInvalidate(); break;
				case 45: fase = 9; postInvalidate(); break;
				case 50: fase = 10; postInvalidate(); break;
				case 55: fase = 11; postInvalidate(); break;
				case 60: fase = 12; postInvalidate(); break;
				case 65: fase = 13; postInvalidate(); break;
				case 70: fase = 14; postInvalidate(); break;
				case 75: fase = 15; postInvalidate(); break;
				case 80: fase = 16; postInvalidate(); break;
				case 85: fase = 17; postInvalidate(); break;
				case 90: fase = 18; postInvalidate(); break;
				case 95: fase = 19; postInvalidate(); break;
				case 100: fase = 20; postInvalidate(); break;
				case 105: fase = 21; postInvalidate(); break;
				case 110: fase = 22; postInvalidate(); break;
				case 115: fase = 23; postInvalidate(); break;
				case 120: fase = 24; postInvalidate(); break;
				case 125: fase = 25; postInvalidate(); break;
				
				}

			}
		}; 

		Timer timer = new Timer(); 
		timer.scheduleAtFixedRate(timerTask, 0, 1000);

	}

	//metodo que dibujara segn la fase
	@SuppressLint("DrawAllocation")
	/** 
     * Metodo para Dibujar la vista
     * @param canvas Objeto que permite pintar en la pantalla
     */
	public void onDraw(Canvas canvas) {
		//en todas las fases se dibuja el robot a la derecha, ocupando segn el tamao de la pantalla
		//cargamos el grafico del robot

		int tamano = context.getResources().getDimensionPixelSize(R.dimen.titulocreditos);
		int tamanomedio = tamano/2;

		switch(fase){
		case 0:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			Bitmap mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			Paint mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			break;
		case 1:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Realizado por", canvas.getWidth()/20, canvas.getHeight()/3, mPaint);
			break;
		case 2:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Realizado por", canvas.getWidth()/20, canvas.getHeight()/3, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Jos Manuel Castellano Domnguez", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			break;

		case 3:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Realizado por", canvas.getWidth()/20, canvas.getHeight()/3, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Jos Manuel Castellano Domnguez", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.RED);
			canvas.drawText("y", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		case 4:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Realizado por", canvas.getWidth()/20, canvas.getHeight()/3, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Jos Manuel Castellano Domnguez", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.RED);
			canvas.drawText("y", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Mariola Monllor Ridaura", canvas.getWidth()/20, 3*canvas.getHeight()/5, mPaint);
			break;
		case 5:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Idea creativa", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			break;
		case 6:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Idea creativa", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Mariola Monllor Ridaura", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		case 7:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Supervisor", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			break;
		case 8:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Supervisor", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Universidad Politcnica de Valencia", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		case 9:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Control de Calidad", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			break;
		case 10:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Control de Calidad", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Mariola Monllor Ridaura", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		case 11:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Bases de Datos e Informacin", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			break;
		case 12:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Bases de Datos e Informacin", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Mariola Monllor Ridaura", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			canvas.drawText("Jos Manuel Castellano Domnguez", canvas.getWidth()/20, 6*canvas.getHeight()/10, mPaint);
			break;
		case 13:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Fotografa", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			break;
		case 14:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Fotografa", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Mariola Monllor Ridaura", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		case 15:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Diseo y Programacin", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			break;
		case 16:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Diseo y Programacin", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Jos Manuel Castellano Domnguez", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		case 17:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Agradecimientos", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			break;
		case 18:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Agradecimientos", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Jess Toms Girons por el gran curso", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		case 19:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Agradecimientos", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Compaeros de la UPV por su gran labor", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		case 20:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Agradecimientos", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("A todos aquellos que nos habeis apoyado", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		
		case 21:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Agradecimientos", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("A mi querida gatita por aguantarme", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		
		case 22:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mrobot = BitmapFactory.decodeResource(getResources(),R.drawable.flor);
			canvas.drawBitmap(mrobot, canvas.getWidth() - mrobot.getWidth(), canvas.getHeight()/10, null);
			mPaint = new Paint();
			mPaint.setTextSize(tamano);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Plantas Alicante", canvas.getWidth()/20, canvas.getHeight()/5, mPaint);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.RED);
			canvas.drawText("Agradecimientos", canvas.getWidth()/20, 2*canvas.getHeight()/5, mPaint);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Y finalmente....", canvas.getWidth()/20, canvas.getHeight()/2, mPaint);
			break;
		case 23:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mPaint = new Paint();
			Bitmap negret = BitmapFactory.decodeResource(getResources(),R.drawable.negret);
			int height = canvas.getHeight();
			//para proporcionarlo
			double difer = negret.getHeight() / height;
			int width = (int) (negret.getWidth() / difer);
			negret = Bitmap.createScaledBitmap(negret, width, height, false);
			canvas.drawBitmap(negret, canvas.getWidth()/2 - negret.getWidth()/2, 0, null);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("A este pequein....", canvas.getWidth()/3, 8*canvas.getHeight()/9, mPaint);
			break;
		case 24:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mPaint = new Paint();
			negret = BitmapFactory.decodeResource(getResources(),R.drawable.negret);
			height = canvas.getHeight();
			//para proporcionarlo
			difer = negret.getHeight() / height;
			width = (int) (negret.getWidth() / difer);
			negret = Bitmap.createScaledBitmap(negret, width, height, false);
			canvas.drawBitmap(negret, canvas.getWidth()/2 - negret.getWidth()/2, 0, null);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("que ya lleva un ao entre nosotros.", canvas.getWidth()/8, 8*canvas.getHeight()/9, mPaint);
			break;
		case 25:
			canvas.drawColor(Color.argb(255, 0, 210, 0));
			mPaint = new Paint();
			negret = BitmapFactory.decodeResource(getResources(),R.drawable.negret);
			height = canvas.getHeight();
			//para proporcionarlo
			difer = negret.getHeight() / height;
			width = (int) (negret.getWidth() / difer);
			negret = Bitmap.createScaledBitmap(negret, width, height, false);
			canvas.drawBitmap(negret, canvas.getWidth()/2 - negret.getWidth()/2, 0, null);
			mPaint.setTextSize(tamanomedio);
			mPaint.setColor(Color.WHITE);
			canvas.drawText("Y que me ha inspirado con sus travesuras.", canvas.getWidth()/10, 8*canvas.getHeight()/9, mPaint);
			break;
		}
	}

}
