package com.plantas.plantasalicante;

import java.util.Timer;
import java.util.TimerTask;

import android.media.MediaPlayer;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.content.Context;
import android.content.SharedPreferences;
import android.support.v4.app.FragmentActivity;
import android.view.WindowManager;

/**
 * Una clase para crear la actividad de Creditos
 * @version 1.0, 26/08/14
 * @author Jose Manuel Castellano Dominguez
 */
public class CreditosActivity extends FragmentActivity {

	private Context context;
	private Creditos creditos;
	private MediaPlayer musica;

	/** 
     * Crea la actividad de creditos.
     * @param savedInstanceState Estado anterior de la actividad.
     */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContext(this.getApplicationContext());
		creditos = new Creditos(this);
		setContentView(creditos);
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		TimerTask timerTask = new TimerTask()
		{
			public void run() 
			{
				finish();
			}

		}; 

		Timer timer = new Timer(); 
		timer.scheduleAtFixedRate(timerTask, 130000,130000 );
	}



	/** 
     * metodo para establecer el contexto de la actividad
     * @param context Contexto de la actividad actual
     */
	private void setContext(Context context){
		this.context=context;
	}

	/** 
     * metodo para cuando se vuelve a la actividad.
     */
	protected void onResume(){
		SharedPreferences pref= PreferenceManager.getDefaultSharedPreferences(this);
		Boolean esmusica = pref.getBoolean("musica", true);
		if(esmusica == true){
		musica = MediaPlayer.create(context,R.raw.evergreen);
		musica.start();
		}
		super.onResume();
	}
	
	/** 
     * metodo para cuando se pausa la actividad
     */
	protected void onPause(){
		SharedPreferences pref= PreferenceManager.getDefaultSharedPreferences(this);
		Boolean esmusica = pref.getBoolean("musica", true);
		if(esmusica == true){
		musica.stop();
		musica.release();
		}
		super.onPause();
		finish();

	}

}
