package com.plantas.plantasalicante;

import java.util.Vector;

import android.app.ListActivity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ListView;

/**
 * Clase que permite representar la actividad Indice
 * @version 1.0, 05/11/14
 * @author Jose Manuel Castellano Dominguez
 */
public class Indice extends ListActivity {

	/** 
	 * Crea la actividad de Indice
	 * @param savedInstanceState Estado anterior de la actividad.
	 */
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.indice);
		Vector<String> almacen = MainActivity.almacen.listaPlantas();
		//ahora dividimos
		Vector<String> nombre_comun = new Vector<String>();
		Vector<String> nombre_cientifico = new Vector<String>();
		Vector<String> tipo = new Vector<String>();
		for(int i = 0; i < almacen.size(); i++){
			String aux = almacen.get(i);
			int pos = aux.indexOf(";");
			nombre_comun.add(aux.substring(0, pos));
			int posaux = aux.substring(pos+1).indexOf(";");
			
			nombre_cientifico.add(aux.substring(pos+1,pos+1 + posaux));
			tipo.add(aux.substring(pos+posaux+2));
		}
		setListAdapter(new MiAdaptador(this,nombre_comun,nombre_cientifico,tipo,0));
	}
	
	/** 
	 * Metodo que permite ejecutar una accion al pulsar uno de los elementos de la lista
	 * @param listView lista sobre la que se ha hecho click
	 * @param vista Vista sobre la que se ha hecho click
	 * @param posicion Numero de elemento sobre el que se ha hecho click
	 * @param id Id del elemento pulsado
	 */
	protected void onListItemClick(ListView listView, View vista, int posicion, long id){
		super.onListItemClick(listView, vista, posicion, id);
		Object o = getListAdapter().getItem(posicion);
		Intent intent = new Intent(this,Ver_Planta.class);
		intent.putExtra("planta", o.toString());
		startActivity(intent);
		
	}
	
	/** 
	 * Metodo que se conecta y accede a la pagina Mi Primer Robot
	 * @param view Vista que fue pulsada
	 */
	//permite acceder a la web de mi primer robot
	public void llamarmiprimerrobot(View view){
		Intent i = new Intent(Intent.ACTION_VIEW,Uri.parse("http://www.mi1robot.es"));
		startActivity(i);
	}
	
	/** 
	 * Metodo que permite crear un menu en la actividad
	 * @param menu Menu que debe inflarse para mostrarse
	 */
	@Override 
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.menu, menu);
		return true; 

	}


	/** 
	 * Metodo que permite clickar sobre las opciones del men
	 * @param item Opcion del menu pulsada
	 */
	@Override 
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.acercaDe:
			//ir al acercade
			startActivity(new Intent(this,AcercaDe.class));
			break;
		case R.id.config:
			//ir a las preferencias
			startActivity(new Intent(this,Preferencias.class));
			break;
		case R.id.usarLupa:
			//ir a la lupa
			startActivity(new Intent(this,Camara.class));
			break;
		case R.id.mapa:
			//ir al mapa
			startActivity(new Intent(this,MapaPlantas.class));
			break;
		}
		return true; 
	}
}
