package com.plantas.plantasalicante;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.view.View;
import android.widget.TextView;

/**
 * Una clase para representar el cuadro de dialogo que pide una letra
 * @version 1.0, 26/08/14
 * @author Jose Manuel Castellano Dominguez
 */
public class RutaDialog extends DialogFragment {
	/** 
	 * Constructor de LetraDialog
	 */
	private int puntuacion;
	public RutaDialog() {
	}
	
	public RutaDialog(int puntuacion) {
		this.puntuacion=puntuacion;
	}

	/** 
	 * Crea el cuadro de dialogo.
	 * @param savedInstanceState Estado anterior del cuadro de dialogo.
	 */
	@SuppressLint("InflateParams")
	@Override
	public Dialog onCreateDialog(Bundle savedInstanceState) {
		// Seleccionar y mostrar el layout a mostrar
		AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(getActivity());
		final View view = getActivity().getLayoutInflater().inflate(R.layout.letra_dialog, null);
		alertDialogBuilder.setView(view);
		//Seteamos el ttulo
		alertDialogBuilder.setTitle("Nota");
		//El botn cancelar
		alertDialogBuilder.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which) {
				//le dio a cancelar, debemos indicar que se cancelo el dialogo
				((MapaPlantas) getActivity()).asignarmarca("cancelar");
				dialog.dismiss();
			}
		});
		//El botn aceptar
		alertDialogBuilder.setPositiveButton("Aceptar", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which) {
				//Obtener el texto ingresado, llamar al mtodo
				//en la actividad principal y cerrar el dilogo
				TextView txtv = (TextView) view.findViewById(R.id.letra);
				((MapaPlantas) getActivity()).asignarmarca(txtv.getText().toString());
				dialog.dismiss();
			}
		});
		return alertDialogBuilder.create();
	}
}
