package com.plantas.plantasalicante;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.Calendar;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.os.IBinder;
import android.os.Looper;
import android.preference.PreferenceManager;
import android.support.v4.app.NotificationCompat;
import android.util.Log;
/**
 * Clase que permite representar el servicio de Zonas
 * @version 1.0, 05/11/14
 * @author Jose Manuel Castellano Dominguez
 */
public class ServicioZonaPlantas extends Service{
	private NotificationManager nm = null;
	private static final int ID_NOTIFICACION_CREAR = 3;
	private Context context;
	private LocationManager manejador;
	private Location mejorLocaliz;
	private Location primeraLocaliz;
	private String antiguolugar;
	private Calendar calaux;
	private static int DOS_MINUTOS = 2*60*1000;
	private String FICHERO = Environment.getExternalStorageDirectory() + "/Android/data/com.plantas.plantasalicante/files/zonaservicio.txt";
	private int km = 10;
	public ServicioZonaPlantas() {
		super();
		context = this;
	}

	/** 
	 * Ejecucion del Servicio
	 * @param intent Intencion asociada al servicio
	 * @param flags Parametros que vienen asociados al servicio
	 * @param startId Id con el que empieza el servicio
	 */
	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		super.onStartCommand(intent, flags, startId); // If this is not written then onHandleIntent is not called.
		//hay que ver si se ha solicitado este servicio
		SharedPreferences pref= PreferenceManager.getDefaultSharedPreferences(this);
		Boolean esGPS = pref.getBoolean("serviciogps", true);
		if(esGPS){
		onHandleIntent(intent);
		return START_STICKY;
		}
		else{
		return START_NOT_STICKY;
		}
	}

	/** 
	 * Metodo que programa las diversas ejecucion del servicio
	 * @param intent Intencion asociada al servicio
	 */
	protected void onHandleIntent(Intent intent) {
		// TODO Auto-generated method stub
		//rescatamos las preferencias
		//debemos programar para cuando nos desplacemos
		//y entremos en otra zona  avise al usuario
		//rescatamos las preferencias
				int min = 0;
				int delayed = 0;
				//comprobamos si hay acceso
				String stadoSD = Environment.getExternalStorageState();
				if(stadoSD.equals(Environment.MEDIA_MOUNTED)){
				File ruta = new File(Environment.getExternalStorageDirectory() + "/Android/data/com.plantas.plantasalicante/files/");
				if (!ruta.exists()) {
					ruta.mkdirs();
				}
				
				calaux = Calendar.getInstance();
				SharedPreferences pref= PreferenceManager.getDefaultSharedPreferences(this);
				String minutos = pref.getString("avisozonatiempo", "60");
				Log.e("Plantas","Programado en " + minutos);
				min = 0;
				try{
					min = Integer.parseInt(minutos);
				}
				catch(Exception e){
					min = 0;
				}
				String kilo = pref.getString("kilometrosdiferencia", "10");
				Log.e("Plantas","Programado en distancia " + kilo);
				try{
					km = Integer.parseInt(kilo);
				}
				catch(Exception e){
					km = 10;
				}
				if(min <= 0 || km <= 0){
					//no debe actualizarse
					//tampoco necesitamos actualizar el fichero
					return;
				}
				
				//ver a que hora es la siguiente ejecucion
				delayed = 0;
				Calendar cal1 = Calendar.getInstance();
				long mili1 = cal1.getTimeInMillis();
				Calendar cal2 = Calendar.getInstance();
				long mili2;
				FileInputStream fos;
				try{
					fos = new FileInputStream(FICHERO);
					BufferedReader entrada = new BufferedReader(new InputStreamReader(fos));
					String linea;
					linea = entrada.readLine();
					//la entrada esta en formato YEAR:MON:DAY:HOUR:MINUTE:SECOND
					String[] fecha =linea.split(":");
					try{
						cal2.set(Integer.parseInt(fecha[0]), Integer.parseInt(fecha[1])-1, Integer.parseInt(fecha[2]), Integer.parseInt(fecha[3]), Integer.parseInt(fecha[4]), Integer.parseInt(fecha[5]));
						mili2 = cal2.getTimeInMillis();
					}
					catch(Exception e){
						Log.e("Plantas","Error al leer de fichero");
						mili2 = mili1;
					}
					entrada.close();
				}
				catch(Exception e){
					mili2 = mili1;
				}
				if(mili2!=mili1 && ((mili2 + (min * 60 * 1000)) > mili1)){
					delayed = (int) ((mili2 + (min * 60 * 1000)) - mili1);
					
				}
				else{
					delayed = 0;
				}}
				else{
					delayed = 0;
				}

	
		Timer timer = new Timer();
		timer.scheduleAtFixedRate(new TimerTask(){

			@Override
			public void run() {
				// TODO Auto-generated method stub
				//primero debemos leer el fichero para recoger los datos
				Log.e("Plantas","Empieza un nuevo service");
				FileInputStream fos;
				String[] coordenadas = null;
				String lugarantiguo = null;
				String lugar = null;
				try{
					fos = new FileInputStream(FICHERO);
					BufferedReader entrada = new BufferedReader(new InputStreamReader(fos));
					String linea;
					linea = entrada.readLine();
					linea = entrada.readLine();
					//en esta segunda linea estan las coordenadas GPS, se leen
					coordenadas = linea.split(" ");
					lugarantiguo = entrada.readLine();
					entrada.close();
				}
				catch(Exception e){
					coordenadas = null;
					lugarantiguo = null;
				}

				//ahora que tenemos los datos de la anterior zona se sacan los de la nueva
				mejorLocaliz = null;
				SharedPreferences pref= PreferenceManager.getDefaultSharedPreferences(context);
				Boolean esGPS = pref.getBoolean("permitirgps", true);
				manejador = (LocationManager) getSystemService(LOCATION_SERVICE);
				if(esGPS && verificaConexion(context)){				
					String opcion = pref.getString("tipos", "2");
					if(manejador.isProviderEnabled(LocationManager.GPS_PROVIDER) && (opcion.equals("0") || opcion.equals("2"))){
						actualizaMejorLocaliz(manejador.getLastKnownLocation(LocationManager.GPS_PROVIDER));
					}
					if (manejador.isProviderEnabled(LocationManager.NETWORK_PROVIDER) && (opcion.equals("1") || opcion.equals("2"))){
						actualizaMejorLocaliz(manejador.getLastKnownLocation(LocationManager.NETWORK_PROVIDER));
					}
				}
				
				
				calaux = Calendar.getInstance();
				FileOutputStream fosaux;
				String year = "" + calaux.get(Calendar.YEAR);
				String month = "" + (calaux.get(Calendar.MONTH) + 1) ;
				String day = "" + calaux.get(Calendar.DAY_OF_MONTH);
				String hour = "" + calaux.get(Calendar.HOUR_OF_DAY);
				String minute = "" + calaux.get(Calendar.MINUTE);
				String second = "" + calaux.get(Calendar.SECOND);
				String cadena = year + ":" + month + ":" + day + ":" + hour + ":" + minute + ":" + second; 
				
				//comprobamos si hay ms de 10 km
				
				if(coordenadas != null && lugarantiguo != null){
					
					primeraLocaliz = new Location("provider");
					primeraLocaliz.setLatitude(Double.parseDouble(coordenadas[0]));
					primeraLocaliz.setLongitude(Double.parseDouble(coordenadas[1]));
					if(mejorLocaliz==null){
						//modificamos solo la hora de salida del fichero
						try {
							fosaux = new FileOutputStream(FICHERO,false);
							cadena = cadena + "\r\n";
							fosaux.write(cadena.getBytes());
							String loca = "" + primeraLocaliz.getLatitude() + " " + primeraLocaliz.getLongitude() + "\r\n" ;
							fosaux.write(loca.getBytes());
							fosaux.write(lugarantiguo.getBytes());
							fosaux.close();
						} catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} 
						return;
					}
					int distanciares = (int)primeraLocaliz.distanceTo(mejorLocaliz);
					if(distanciares > km * 1000){
						//ok, son mas de 10km de distancia, vamos a Internet
						TareaGPS tg = new TareaGPS();
						tg.execute(1);
						lugar = "No encontrado";
						try {
							//como es un servicio dejamos 10 segundos
							lugar = tg.get(10,TimeUnit.SECONDS);
						} catch (InterruptedException | ExecutionException | TimeoutException e) {
							// TODO Auto-generated catch block
							lugar = "No encontrado";
						}
						//Log.e("Plantas",lugarantiguo);
						if(lugarantiguo.equals("Lugar No encontrado") || lugarantiguo.equals("No encontrado")){ 
							//debemos actualizar el fichero de hora
							
							try {
								fosaux = new FileOutputStream(FICHERO,false);
								cadena = cadena + "\r\n";
								fosaux.write(cadena.getBytes());
								String loca = "" + primeraLocaliz.getLatitude() + " " + primeraLocaliz.getLongitude() + "\r\n" ;
								fosaux.write(loca.getBytes());
								fosaux.write(lugar.getBytes());
								fosaux.close();
							} catch (Exception e) {
								// TODO Auto-generated catch block
								Log.e("Plantas","ERROR AL GUARDAR");
								e.printStackTrace();
							} 
							
							return; 
							}
						if(lugarantiguo.equals(lugar) || lugar.equals("No encontrado")){
							try {
								fosaux = new FileOutputStream(FICHERO,false);
								cadena = cadena + "\r\n";
								fosaux.write(cadena.getBytes());
								String loca = "" + primeraLocaliz.getLatitude() + " " + primeraLocaliz.getLongitude() + "\r\n" ;
								fosaux.write(loca.getBytes());
								fosaux.write(lugarantiguo.getBytes());
								fosaux.close();
							} catch (Exception e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							} 
							
							return; }
						//si llegamos aqui son 2 sitios distintos, debemos avisar que estamos en un nuevo sitio
						Log.e("Plantas", "Plantas en nueva zona " + lugarantiguo + " a " + lugar);
						nm =(NotificationManager)getApplicationContext().getSystemService(Context.NOTIFICATION_SERVICE);
						NotificationCompat.Builder notific = new NotificationCompat.Builder(context).setContentTitle("Plantas en " + lugar )
					             .setSmallIcon(R.drawable.ic_launcher)
					             .setContentText("Hay nuevas plantas en la zona donde estas");

							
							PendingIntent intencionPendiente = PendingIntent.getActivity(context, 0, new Intent(context,Zona.class), 0);
							notific.setContentIntent(intencionPendiente);
							nm.notify(ID_NOTIFICACION_CREAR, notific.build());
						antiguolugar = lugar;
						primeraLocaliz = mejorLocaliz;
						try{
							//primero deberiamos borrar el fichero si existe
							fosaux = new FileOutputStream(FICHERO,false);
							cadena = cadena + "\r\n";
							fosaux.write(cadena.getBytes());
							String loca = "" + mejorLocaliz.getLatitude() + " " + mejorLocaliz.getLongitude() + "\r\n" ;
							fosaux.write(loca.getBytes());
							fosaux.write(lugar.getBytes());
							fosaux.close();
						}
						catch(Exception e){
							Log.e("Plantas", "No se ha podido crear el fichero de salida");
						}
						
					}
					else{
						//no hay mas de la distancia
						//guardamos los datos antiguos y la hora y nos vamos
						if(lugar==null){
							TareaGPS tg = new TareaGPS();
							tg.execute(1);
							lugar = "No encontrado";
							try {
								lugar = tg.get(4,TimeUnit.SECONDS);
							} catch (InterruptedException | ExecutionException | TimeoutException e) {
								// TODO Auto-generated catch block
								lugar = "No encontrado";
							}
						}
						try {
							fosaux = new FileOutputStream(FICHERO,false);
							cadena = cadena + "\r\n";
							fosaux.write(cadena.getBytes());
							String loca = "" + primeraLocaliz.getLatitude() + " " + primeraLocaliz.getLongitude() + "\r\n" ;
							fosaux.write(loca.getBytes());
							fosaux.write(lugar.getBytes());
							fosaux.close();
						} catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} 
						return;
					}
					
				}
				else{
					//debemos grabar nuevos datos
					//debemos guardar el nuevo sitio encontrado
					if(lugar==null){
						TareaGPS tg = new TareaGPS();
						tg.execute(1);
						lugar = "No encontrado";
						try {
							lugar = tg.get(4,TimeUnit.SECONDS);
						} catch (InterruptedException | ExecutionException | TimeoutException e) {
							// TODO Auto-generated catch block
							lugar = "No encontrado";
						}
					}
					try{
						//primero deberiamos borrar el fichero si existe
						fosaux = new FileOutputStream(FICHERO,false);
						cadena = cadena + "\r\n";
						fosaux.write(cadena.getBytes());
						String loca = "" + mejorLocaliz.getLatitude() + " " + mejorLocaliz.getLongitude() + "\r\n" ;
						fosaux.write(loca.getBytes());
						fosaux.write(lugar.getBytes());
						fosaux.close();
					}
					catch(Exception e){
						Log.e("Plantas", "No se ha podido crear el fichero de salida");
					}
				}
				
			
				
				//una vez por hora se comprueba la localizacion actual
				
				
			}


		}, delayed, min * 60 * 1000);


	}

	/**
	 * Clase que se ejecutar en otro hilo y permitir recuperar la ubicacion actual
	 * @version 1.0, 05/11/14
	 * @author Jose Manuel Castellano Dominguez
	 */
	private class TareaGPS extends AsyncTask<Integer,Void,String>{

		/** 
		 * Metodo que ejecuta la tarea
		 * @param cantidad cantidad de datos a pedir
		 */
		protected String doInBackground(Integer... cantidad){
			String result = null;
			Boolean hayconexion=verificaConexion(context);
			if(!hayconexion){
				//no podemos conectarnos, abortamos
				return null;
			}
			try {
				URL url= new URL("https://maps.googleapis.com/maps/api/geocode/xml?latlng=" + mejorLocaliz.getLatitude() + "," + mejorLocaliz.getLongitude() +"&sensor=true");	
				SAXParserFactory fabrica = SAXParserFactory.newInstance();
				SAXParser parser = fabrica.newSAXParser();
				XMLReader lector = parser.getXMLReader();
				ManejadorXML manejadorXML = new ManejadorXML();
				lector.setContentHandler(manejadorXML);
				InputSource datos = new InputSource(url.openStream());
				lector.parse(datos);
				//ahora deberemos llamar a una actividad suponiendo que no se cumpla
				return manejadorXML.getTotalResults();
			}
			catch(Exception e){
				Log.e("Plantas", "Excepcion:" + e.getMessage(), e);
			}
			return result;
		}

	}

	/**
	 * Clase que permite manejar los datos XML del servicio de geolocalizacion de google
	 * @version 1.0, 05/11/14
	 * @author Jose Manuel Castellano Dominguez
	 */
	public class ManejadorXML extends DefaultHandler{
		private String totalResults;
		private StringBuilder cadena = new StringBuilder();
		private String provincia;
		/** 
		 * Devuelve la cadena encontrada
		 */
		public String getTotalResults(){
			return totalResults;
		}
		/** 
		 * Metodo que empieza a parsear un nuevo elemento
		 * @param uri Cadena de la direccion que empieza
		 * @param nombreLocal El dato que viene dentro de la clave XML
		 * @param nombreCualif La clave XML
		 * @param atributos Datos asociados a la clave XML
		 */
		public void startElement(String uri, String nombreLocal, String nombreCualif, Attributes atributos) throws SAXException {
			cadena.setLength(0);
		}
		/** 
		 * Metodo que corta y rejunta trozos de claves
		 * @param ch Trozo de cadena a rejuntar
		 * @param comienzo posicion desde donde debe empezar a copiar
		 * @param lon longitud del trozo a copiar
		 */
		public void characters(char ch[], int comienzo, int lon){
			cadena.append(ch,comienzo,lon);
		}
		/** 
		 * Metodo determina que se ha terminado de analizar una clave
		 * @param uri Cadena de la direccion que termina
		 * @param nombreLocal El dato que viene dentro de la clave XML
		 * @param nombreCualif La clave XML
		 */
		public void endElement(String uri, String nombreLocal, String nombreCualif) throws SAXException{
			if(nombreLocal.equals("type") && cadena.toString().equals("administrative_area_level_4")){
				//si es esta area tenemos la provincia
				totalResults= provincia;
			}
			else{
				//comprobemos si es un long_name
				if(nombreLocal.equals("long_name")){
					provincia = cadena.toString();

				}
			}
		}


	}

	/** 
	 * Metodo que nos permite bindear el servicio (No se bindea)
	 * @param intent Intencion asociada al servicio
	 */
	@Override
	public IBinder onBind(Intent intent) {
		// TODO Auto-generated method stub
		return null;
	}
	/** 
	 * Metodo que permite determinar si hay conexion a Internet o no
	 * @param ctx Contexto donde se ejecuta la funcion
	 */
	public static boolean verificaConexion(Context ctx) {
		boolean bConectado = false;
		ConnectivityManager connec = (ConnectivityManager) ctx
				.getSystemService(Context.CONNECTIVITY_SERVICE);
		// No slo wifi, tambin GPRS
		NetworkInfo[] redes = connec.getAllNetworkInfo();
		// este bucle debera no ser tan apa
		for (int i = 0; i < 2; i++) {
			// Tenemos conexin? ponemos a true
			if (redes[i].getState() == NetworkInfo.State.CONNECTED) {
				bConectado = true;
			}
		}
		return bConectado;
	}
	/** 
	 * Metodo que permite actualizar la localizacion si es mejor a la ya guardada
	 * @param localiz Localizacion GPS obtenida
	 */
	private void actualizaMejorLocaliz(Location localiz){
		if(localiz != null && (mejorLocaliz == null || localiz.getAccuracy() < 2*mejorLocaliz.getAccuracy() || localiz.getTime() - mejorLocaliz.getTime() > DOS_MINUTOS)){
			mejorLocaliz = localiz;
		}
	}

}
