package com.plantas.plantasalicante;

import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import com.plantas.plantasalicante.Zona.ManejadorXML;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
/**
 * Clase que permite mostrar la informacin de una planta
 * @version 1.0, 05/11/14
 * @author Jose Manuel Castellano Dominguez
 */
public class Ver_Planta extends Activity {
	private Context context;

	/** 
	 * Crea la actividad de Ver Planta
	 * @param savedInstanceState Estado anterior de la actividad.
	 */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		context = this;
		setContentView(R.layout.activity_ver__planta);
		String nombre = getIntent().getStringExtra("planta");
		//recuperamos las plantas del content provider
		Cursor info = MainActivity.almacen.PlantaBuscada(nombre);
		info.moveToNext();
		SharedPreferences pref= PreferenceManager.getDefaultSharedPreferences(this);
		Boolean fotoplanta = pref.getBoolean("fotoplanta", true);
		ImageView foto_planta = (ImageView) this.findViewById(R.id.imagenplanta);
		if(fotoplanta){
			//debemos descargar la foto de Internet
			URL imageUrl = null;
			String nombresinespacios = nombre.trim().replace(" ", "");
			nombresinespacios = nombresinespacios.replace("", "n");
			String imageHttpAddress = "http://www.mi1robot.es/plantas/" + nombresinespacios;
			//ahora necesitamos obtener el tamao de la pantalla
			if (((getResources().getConfiguration().screenLayout & 
					Configuration.SCREENLAYOUT_SIZE_MASK) == 
					Configuration.SCREENLAYOUT_SIZE_LARGE)) {
				imageHttpAddress = imageHttpAddress + "large.jpg";
			}
			if (((getResources().getConfiguration().screenLayout & 
					Configuration.SCREENLAYOUT_SIZE_MASK) == 
					Configuration.SCREENLAYOUT_SIZE_XLARGE)) {
				imageHttpAddress = imageHttpAddress + "xlarge.jpg";
			}
			if (((getResources().getConfiguration().screenLayout & 
					Configuration.SCREENLAYOUT_SIZE_MASK) == 
					Configuration.SCREENLAYOUT_SIZE_SMALL)) {
				imageHttpAddress = imageHttpAddress + "small.jpg";
			}
			if (((getResources().getConfiguration().screenLayout & 
					Configuration.SCREENLAYOUT_SIZE_MASK) == 
					Configuration.SCREENLAYOUT_SIZE_NORMAL) || ((getResources().getConfiguration().screenLayout & 
							Configuration.SCREENLAYOUT_SIZE_MASK) == 
							Configuration.SCREENLAYOUT_SIZE_UNDEFINED)) {
				imageHttpAddress = imageHttpAddress + "normal.jpg";
			}
			TareaFoto tf = new TareaFoto();
			tf.execute(imageHttpAddress);
			Bitmap loadedImage;
			try {
				loadedImage = tf.get(4,TimeUnit.SECONDS);
			} catch (InterruptedException | ExecutionException
					| TimeoutException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				loadedImage = null;
			}
			if(loadedImage == null){
				foto_planta.setVisibility(View.GONE);
			}
			else{
				 foto_planta.setImageBitmap(loadedImage);
			}	
		}
		else{
			foto_planta.setVisibility(View.GONE);
		}
		Boolean nombrecomun = pref.getBoolean("nombrecomun", true);
		TextView nombre_comun = (TextView) this.findViewById(R.id.nombre_comun);
		if(nombrecomun){
		nombre_comun.setText("NOMBRE COMUN: " + info.getString(info.getColumnIndex("nombre_comun")));
		}
		else{
			nombre_comun.setVisibility(View.GONE);
		}
		Boolean nombrecientifico = pref.getBoolean("nombrecientifico", true);
		TextView nombre_cientifico = (TextView) this.findViewById(R.id.nombre_cientifico);
		if(nombrecientifico){
		nombre_cientifico.setText("NOMBRE CIENTIFICO: " + info.getString(info.getColumnIndex("nombre_cientifico")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}
		nombrecientifico = pref.getBoolean("familiaplanta", true);
		nombre_cientifico = (TextView) this.findViewById(R.id.familia);
		if(nombrecientifico){
		nombre_cientifico.setText("FAMILIA: " + info.getString(info.getColumnIndex("familia")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}
		nombrecientifico = pref.getBoolean("floracionplanta", true);
		nombre_cientifico = (TextView) this.findViewById(R.id.floracion);
		if(nombrecientifico){
		nombre_cientifico.setText("FLORACION: " + info.getString(info.getColumnIndex("floracion")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}
		nombrecientifico = pref.getBoolean("distribucionplanta", true);
		nombre_cientifico = (TextView) this.findViewById(R.id.distribucion);
		if(nombrecientifico){
		nombre_cientifico.setText("DISTRIBUCION: " + info.getString(info.getColumnIndex("distribucion")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}
		nombrecientifico = pref.getBoolean("ecologiaplanta", true);
		nombre_cientifico = (TextView) this.findViewById(R.id.ecologia);
		if(nombrecientifico){
		nombre_cientifico.setText("ECOLOGIA: " + info.getString(info.getColumnIndex("ecologia")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}
		nombrecientifico = pref.getBoolean("alturaplanta", true);
		nombre_cientifico = (TextView) this.findViewById(R.id.altura);
		if(nombrecientifico){
		nombre_cientifico.setText("ALTURA: " + info.getString(info.getColumnIndex("altura")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}
		nombrecientifico = pref.getBoolean("biotipoplanta", true);
		nombre_cientifico = (TextView) this.findViewById(R.id.biotipo);
		if(nombrecientifico){
		nombre_cientifico.setText("BIOTIPO: " + info.getString(info.getColumnIndex("biotipo")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}
		nombrecientifico = pref.getBoolean("abundanciaplanta", true);
		nombre_cientifico = (TextView) this.findViewById(R.id.abundancia);
		if(nombrecientifico){
		nombre_cientifico.setText("ABUNDANCIA: " + info.getString(info.getColumnIndex("abundancia")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}
		nombrecientifico = pref.getBoolean("uicnplanta", true);
		nombre_cientifico = (TextView) this.findViewById(R.id.uicn);
		if(nombrecientifico){
		nombre_cientifico.setText("UICN: " + info.getString(info.getColumnIndex("uicn")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}
		
		nombrecientifico = pref.getBoolean("descripcionplanta", true);
		nombre_cientifico = (TextView) this.findViewById(R.id.descripcion);
		if(nombrecientifico){
		nombre_cientifico.setText("DESCRIPCION: " + info.getString(info.getColumnIndex("descripcion")));
		}
		else{
			nombre_cientifico.setVisibility(View.GONE);
		}

	}
	
	/**
	 * Clase que se ejecutar en otro hilo y recuperar una imagen de Internet
	 * @version 1.0, 05/11/14
	 * @author Jose Manuel Castellano Dominguez
	 */
	private class TareaFoto extends AsyncTask<String,Void,Bitmap>{
		
		/** 
		 * Metodo que ejecuta la tarea
		 * @param ruta Ruta de la imagen a descargar
		 */
		protected Bitmap doInBackground(String... ruta){
			String result= null;
			try {
				Boolean hayconexion=verificaConexion(context);
				if(!hayconexion){
					//no podemos conectarnos, abortamos
					return null;
				}
				URL imageUrl = new URL(ruta[0]);
				HttpURLConnection conn = (HttpURLConnection) imageUrl.openConnection();
	            conn.connect();
	            return  BitmapFactory.decodeStream(conn.getInputStream());
			}
			catch(Exception e){
				Log.e("Plantas", "Excepcion:" + e.getMessage(), e);
			}
			return null;
		}
	}
	
	/** 
	 * Metodo que permite determinar si hay conexion a Internet o no
	 * @param ctx Contexto donde se ejecuta la funcion
	 */
	public static boolean verificaConexion(Context ctx) {
	    boolean bConectado = false;
	    ConnectivityManager connec = (ConnectivityManager) ctx
	            .getSystemService(Context.CONNECTIVITY_SERVICE);
	    // No slo wifi, tambin GPRS
	    NetworkInfo[] redes = connec.getAllNetworkInfo();
	    // este bucle debera no ser tan apa
	    for (int i = 0; i < 2; i++) {
	        // Tenemos conexin? ponemos a true
	        if (redes[i].getState() == NetworkInfo.State.CONNECTED) {
	            bConectado = true;
	        }
	    }
	    return bConectado;
	}
}
